# coding: utf-8

"""
    CyberSource Flex API

    Simple PAN tokenization service

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class InlineResponse2002OrderInformationAmountDetails(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'authorized_amount': 'str',
        'total_amount': 'str',
        'currency': 'str',
        'discount_amount': 'str',
        'duty_amount': 'str',
        'tax_amount': 'str',
        'national_tax_included': 'str',
        'freight_amount': 'str',
        'tax_details': 'list[V2paymentsOrderInformationAmountDetailsTaxDetails]'
    }

    attribute_map = {
        'authorized_amount': 'authorizedAmount',
        'total_amount': 'totalAmount',
        'currency': 'currency',
        'discount_amount': 'discountAmount',
        'duty_amount': 'dutyAmount',
        'tax_amount': 'taxAmount',
        'national_tax_included': 'nationalTaxIncluded',
        'freight_amount': 'freightAmount',
        'tax_details': 'taxDetails'
    }

    def __init__(self, authorized_amount=None, total_amount=None, currency=None, discount_amount=None, duty_amount=None, tax_amount=None, national_tax_included=None, freight_amount=None, tax_details=None):
        """
        InlineResponse2002OrderInformationAmountDetails - a model defined in Swagger
        """

        self._authorized_amount = None
        self._total_amount = None
        self._currency = None
        self._discount_amount = None
        self._duty_amount = None
        self._tax_amount = None
        self._national_tax_included = None
        self._freight_amount = None
        self._tax_details = None

        if authorized_amount is not None:
          self.authorized_amount = authorized_amount
        if total_amount is not None:
          self.total_amount = total_amount
        if currency is not None:
          self.currency = currency
        if discount_amount is not None:
          self.discount_amount = discount_amount
        if duty_amount is not None:
          self.duty_amount = duty_amount
        if tax_amount is not None:
          self.tax_amount = tax_amount
        if national_tax_included is not None:
          self.national_tax_included = national_tax_included
        if freight_amount is not None:
          self.freight_amount = freight_amount
        if tax_details is not None:
          self.tax_details = tax_details

    @property
    def authorized_amount(self):
        """
        Gets the authorized_amount of this InlineResponse2002OrderInformationAmountDetails.
        Amount that was authorized. 

        :return: The authorized_amount of this InlineResponse2002OrderInformationAmountDetails.
        :rtype: str
        """
        return self._authorized_amount

    @authorized_amount.setter
    def authorized_amount(self, authorized_amount):
        """
        Sets the authorized_amount of this InlineResponse2002OrderInformationAmountDetails.
        Amount that was authorized. 

        :param authorized_amount: The authorized_amount of this InlineResponse2002OrderInformationAmountDetails.
        :type: str
        """
        if authorized_amount is not None and len(authorized_amount) > 15:
            raise ValueError("Invalid value for `authorized_amount`, length must be less than or equal to `15`")

        self._authorized_amount = authorized_amount

    @property
    def total_amount(self):
        """
        Gets the total_amount of this InlineResponse2002OrderInformationAmountDetails.
        Grand total for the order. You can include a decimal point (.), but no other special characters. CyberSource truncates the amount to the correct number of decimal places.  * CTV, FDCCompass, Paymentech (<= 12)  For processor-specific information, see the grand_total_amount field in [Credit Card Services Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html) 

        :return: The total_amount of this InlineResponse2002OrderInformationAmountDetails.
        :rtype: str
        """
        return self._total_amount

    @total_amount.setter
    def total_amount(self, total_amount):
        """
        Sets the total_amount of this InlineResponse2002OrderInformationAmountDetails.
        Grand total for the order. You can include a decimal point (.), but no other special characters. CyberSource truncates the amount to the correct number of decimal places.  * CTV, FDCCompass, Paymentech (<= 12)  For processor-specific information, see the grand_total_amount field in [Credit Card Services Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html) 

        :param total_amount: The total_amount of this InlineResponse2002OrderInformationAmountDetails.
        :type: str
        """
        if total_amount is not None and len(total_amount) > 19:
            raise ValueError("Invalid value for `total_amount`, length must be less than or equal to `19`")

        self._total_amount = total_amount

    @property
    def currency(self):
        """
        Gets the currency of this InlineResponse2002OrderInformationAmountDetails.
        Currency used for the order. Use the three-character ISO Standard Currency Codes.  For an authorization reversal or a capture, you must use the same currency that you used in your request for Payment API. 

        :return: The currency of this InlineResponse2002OrderInformationAmountDetails.
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """
        Sets the currency of this InlineResponse2002OrderInformationAmountDetails.
        Currency used for the order. Use the three-character ISO Standard Currency Codes.  For an authorization reversal or a capture, you must use the same currency that you used in your request for Payment API. 

        :param currency: The currency of this InlineResponse2002OrderInformationAmountDetails.
        :type: str
        """
        if currency is not None and len(currency) > 3:
            raise ValueError("Invalid value for `currency`, length must be less than or equal to `3`")

        self._currency = currency

    @property
    def discount_amount(self):
        """
        Gets the discount_amount of this InlineResponse2002OrderInformationAmountDetails.
        Total discount amount applied to the order.  For processor-specific information, see the order_discount_amount field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :return: The discount_amount of this InlineResponse2002OrderInformationAmountDetails.
        :rtype: str
        """
        return self._discount_amount

    @discount_amount.setter
    def discount_amount(self, discount_amount):
        """
        Sets the discount_amount of this InlineResponse2002OrderInformationAmountDetails.
        Total discount amount applied to the order.  For processor-specific information, see the order_discount_amount field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :param discount_amount: The discount_amount of this InlineResponse2002OrderInformationAmountDetails.
        :type: str
        """
        if discount_amount is not None and len(discount_amount) > 15:
            raise ValueError("Invalid value for `discount_amount`, length must be less than or equal to `15`")

        self._discount_amount = discount_amount

    @property
    def duty_amount(self):
        """
        Gets the duty_amount of this InlineResponse2002OrderInformationAmountDetails.
        Total charges for any import or export duties included in the order.  For processor-specific information, see the duty_amount field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :return: The duty_amount of this InlineResponse2002OrderInformationAmountDetails.
        :rtype: str
        """
        return self._duty_amount

    @duty_amount.setter
    def duty_amount(self, duty_amount):
        """
        Sets the duty_amount of this InlineResponse2002OrderInformationAmountDetails.
        Total charges for any import or export duties included in the order.  For processor-specific information, see the duty_amount field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :param duty_amount: The duty_amount of this InlineResponse2002OrderInformationAmountDetails.
        :type: str
        """
        if duty_amount is not None and len(duty_amount) > 15:
            raise ValueError("Invalid value for `duty_amount`, length must be less than or equal to `15`")

        self._duty_amount = duty_amount

    @property
    def tax_amount(self):
        """
        Gets the tax_amount of this InlineResponse2002OrderInformationAmountDetails.
        Total tax amount for all the items in the order.  For processor-specific information, see the total_tax_amount field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :return: The tax_amount of this InlineResponse2002OrderInformationAmountDetails.
        :rtype: str
        """
        return self._tax_amount

    @tax_amount.setter
    def tax_amount(self, tax_amount):
        """
        Sets the tax_amount of this InlineResponse2002OrderInformationAmountDetails.
        Total tax amount for all the items in the order.  For processor-specific information, see the total_tax_amount field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :param tax_amount: The tax_amount of this InlineResponse2002OrderInformationAmountDetails.
        :type: str
        """
        if tax_amount is not None and len(tax_amount) > 12:
            raise ValueError("Invalid value for `tax_amount`, length must be less than or equal to `12`")

        self._tax_amount = tax_amount

    @property
    def national_tax_included(self):
        """
        Gets the national_tax_included of this InlineResponse2002OrderInformationAmountDetails.
        Flag that indicates whether a national tax is included in the order total.  Possible values:   - **0**: national tax not included  - **1**: national tax included  For processor-specific information, see the national_tax_indicator field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :return: The national_tax_included of this InlineResponse2002OrderInformationAmountDetails.
        :rtype: str
        """
        return self._national_tax_included

    @national_tax_included.setter
    def national_tax_included(self, national_tax_included):
        """
        Sets the national_tax_included of this InlineResponse2002OrderInformationAmountDetails.
        Flag that indicates whether a national tax is included in the order total.  Possible values:   - **0**: national tax not included  - **1**: national tax included  For processor-specific information, see the national_tax_indicator field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :param national_tax_included: The national_tax_included of this InlineResponse2002OrderInformationAmountDetails.
        :type: str
        """
        if national_tax_included is not None and len(national_tax_included) > 1:
            raise ValueError("Invalid value for `national_tax_included`, length must be less than or equal to `1`")

        self._national_tax_included = national_tax_included

    @property
    def freight_amount(self):
        """
        Gets the freight_amount of this InlineResponse2002OrderInformationAmountDetails.
        Total freight or shipping and handling charges for the order. When you include this field in your request, you must also include the **totalAmount** field.  For processor-specific information, see the freight_amount field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :return: The freight_amount of this InlineResponse2002OrderInformationAmountDetails.
        :rtype: str
        """
        return self._freight_amount

    @freight_amount.setter
    def freight_amount(self, freight_amount):
        """
        Sets the freight_amount of this InlineResponse2002OrderInformationAmountDetails.
        Total freight or shipping and handling charges for the order. When you include this field in your request, you must also include the **totalAmount** field.  For processor-specific information, see the freight_amount field in [Level II and Level III Processing Using the SCMP API.](http://apps.cybersource.com/library/documentation/dev_guides/Level_2_3_SCMP_API/html) 

        :param freight_amount: The freight_amount of this InlineResponse2002OrderInformationAmountDetails.
        :type: str
        """
        if freight_amount is not None and len(freight_amount) > 13:
            raise ValueError("Invalid value for `freight_amount`, length must be less than or equal to `13`")

        self._freight_amount = freight_amount

    @property
    def tax_details(self):
        """
        Gets the tax_details of this InlineResponse2002OrderInformationAmountDetails.

        :return: The tax_details of this InlineResponse2002OrderInformationAmountDetails.
        :rtype: list[V2paymentsOrderInformationAmountDetailsTaxDetails]
        """
        return self._tax_details

    @tax_details.setter
    def tax_details(self, tax_details):
        """
        Sets the tax_details of this InlineResponse2002OrderInformationAmountDetails.

        :param tax_details: The tax_details of this InlineResponse2002OrderInformationAmountDetails.
        :type: list[V2paymentsOrderInformationAmountDetailsTaxDetails]
        """

        self._tax_details = tax_details

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, InlineResponse2002OrderInformationAmountDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
